org.apache.hc.client5.http.classic

## Interface HttpClient

- All Known Implementing Classes:
    CloseableHttpClient, MinimalHttpClient

      public interface HttpClient

  This interface represents only the most basic contract for HTTP request execution. It imposes no restrictions or particular details on the request execution process and leaves the specifics of state management, authentication and redirect handling up to individual implementations.
  Since:
    4.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `HttpResponse` | `execute(ClassicHttpRequest request)` Deprecated. It is strongly recommended to use execute methods with `HttpClientResponseHandler` such as `execute(ClassicHttpRequest, HttpClientResponseHandler)` in order to ensure automatic resource deallocation by the client. For special cases one can still use `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)` to keep the response object open after the request execution.
    `<T> T` | `execute(ClassicHttpRequest request, HttpClientResponseHandler<? extends T> responseHandler)` Executes HTTP request using the default context and processes the response using the given response handler.
    `HttpResponse` | `execute(ClassicHttpRequest request, HttpContext context)` Deprecated. It is strongly recommended to use execute methods with `HttpClientResponseHandler` such as `execute(ClassicHttpRequest, HttpContext, HttpClientResponseHandler)` in order to ensure automatic resource deallocation by the client. For special cases one can still use `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)` to keep the response object open after the request execution.
    `<T> T` | `execute(ClassicHttpRequest request, HttpContext context, HttpClientResponseHandler<? extends T> responseHandler)` Executes HTTP request using the given context and processes the response using the given response handler.
    `ClassicHttpResponse` | `execute(HttpHost target, ClassicHttpRequest request)` Deprecated. It is strongly recommended to use execute methods with `HttpClientResponseHandler` such as `execute(HttpHost, ClassicHttpRequest, HttpClientResponseHandler)` in order to ensure automatic resource deallocation by the client. For special cases one can still use `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)` to keep the response object open after the request execution.
    `<T> T` | `execute(HttpHost target, ClassicHttpRequest request, HttpClientResponseHandler<? extends T> responseHandler)` Executes HTTP request to the target using the default context and processes the response using the given response handler.
    `HttpResponse` | `execute(HttpHost target, ClassicHttpRequest request, HttpContext context)` Deprecated. It is strongly recommended to use execute methods with `HttpClientResponseHandler` such as `execute(HttpHost, ClassicHttpRequest, HttpContext, HttpClientResponseHandler)` in order to ensure automatic resource deallocation by the client. For special cases one can still use `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)` to keep the response object open after the request execution.
    `<T> T` | `execute(HttpHost target, ClassicHttpRequest request, HttpContext context, HttpClientResponseHandler<? extends T> responseHandler)` Executes HTTP request to the target using the given context and processes the response using the given response handler.
    `default ClassicHttpResponse` | `executeOpen(HttpHost target, ClassicHttpRequest request, HttpContext context)` Executes the request and opens the response stream using the given context.

- - ### Method Detail

    - #### execute

          @Deprecated
          HttpResponse execute(ClassicHttpRequest request)
                                    throws IOException

      Deprecated. It is strongly recommended to use execute methods with `HttpClientResponseHandler` such as `execute(ClassicHttpRequest, HttpClientResponseHandler)` in order to ensure automatic resource deallocation by the client. For special cases one can still use `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)` to keep the response object open after the request execution.
      Executes HTTP request using the default context.
      Parameters:
        `request` - the request to execute
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
      See Also:
        `execute(ClassicHttpRequest, HttpClientResponseHandler)`, `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)`

    - #### execute

          @Deprecated
          HttpResponse execute(ClassicHttpRequest request,
                                           HttpContext context)
                                    throws IOException

      Deprecated. It is strongly recommended to use execute methods with `HttpClientResponseHandler` such as `execute(ClassicHttpRequest, HttpContext, HttpClientResponseHandler)` in order to ensure automatic resource deallocation by the client. For special cases one can still use `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)` to keep the response object open after the request execution.
      Executes HTTP request using the given context.
      Parameters:
        `request` - the request to execute
        `context` - the context to use for the execution, or `null` to use the default context
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
      See Also:
        `execute(ClassicHttpRequest, HttpContext, HttpClientResponseHandler)`, `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)`

    - #### execute

          @Deprecated
          ClassicHttpResponse execute(HttpHost target,
                                                  ClassicHttpRequest request)
                                           throws IOException

      Deprecated. It is strongly recommended to use execute methods with `HttpClientResponseHandler` such as `execute(HttpHost, ClassicHttpRequest, HttpClientResponseHandler)` in order to ensure automatic resource deallocation by the client. For special cases one can still use `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)` to keep the response object open after the request execution.
      Executes HTTP request using the default context.
      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
      See Also:
        `execute(HttpHost, ClassicHttpRequest, HttpClientResponseHandler)`, `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)`

    - #### execute

          @Deprecated
          HttpResponse execute(HttpHost target,
                                           ClassicHttpRequest request,
                                           HttpContext context)
                                    throws IOException

      Deprecated. It is strongly recommended to use execute methods with `HttpClientResponseHandler` such as `execute(HttpHost, ClassicHttpRequest, HttpContext, HttpClientResponseHandler)` in order to ensure automatic resource deallocation by the client. For special cases one can still use `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)` to keep the response object open after the request execution.
      Executes HTTP request using the given context.
      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `context` - the context to use for the execution, or `null` to use the default context
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
      See Also:
        `execute(HttpHost, ClassicHttpRequest, HttpContext, HttpClientResponseHandler)`, `executeOpen(HttpHost, ClassicHttpRequest, HttpContext)`

    - #### executeOpen

          default ClassicHttpResponse executeOpen(HttpHost target,
                                                  ClassicHttpRequest request,
                                                  HttpContext context)
                                           throws IOException

      Executes the request and opens the response stream using the given context.
      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `context` - the context to use for the execution, or `null` to use the default context
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client. The response returned by this method must be closed with `Closeable.close()` in order ensure deallocation of system resources.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
      Since:
        5.2

    - #### execute

          <T> T execute(ClassicHttpRequest request,
                        HttpClientResponseHandler<? extends T> responseHandler)
                 throws IOException

      Executes HTTP request using the default context and processes the response using the given response handler.

      Implementing classes are required to ensure that the content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `HttpClientResponseHandler`s from having to manage resource deallocation internally.

      Parameters:
        `request` - the request to execute
        `responseHandler` - the response handler
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted

    - #### execute

          <T> T execute(ClassicHttpRequest request,
                        HttpContext context,
                        HttpClientResponseHandler<? extends T> responseHandler)
                 throws IOException

      Executes HTTP request using the given context and processes the response using the given response handler.

      Implementing classes are required to ensure that the content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `HttpClientResponseHandler`s from having to manage resource deallocation internally.

      Parameters:
        `request` - the request to execute
        `context` - the context to use for the execution, or `null` to use the default context
        `responseHandler` - the response handler
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted

    - #### execute

          <T> T execute(HttpHost target,
                        ClassicHttpRequest request,
                        HttpClientResponseHandler<? extends T> responseHandler)
                 throws IOException

      Executes HTTP request to the target using the default context and processes the response using the given response handler.

      Implementing classes are required to ensure that the content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `HttpClientResponseHandler`s from having to manage resource deallocation internally.

      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `responseHandler` - the response handler
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted

    - #### execute

          <T> T execute(HttpHost target,
                        ClassicHttpRequest request,
                        HttpContext context,
                        HttpClientResponseHandler<? extends T> responseHandler)
                 throws IOException

      Executes HTTP request to the target using the given context and processes the response using the given response handler.

      Implementing classes are required to ensure that the content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `HttpClientResponseHandler`s from having to manage resource deallocation internally.

      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `context` - the context to use for the execution, or `null` to use the default context
        `responseHandler` - the response handler
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted

Copyright © 1999–2021 The Apache Software Foundation. All rights reserved.